import {select, csv, scaleLinear, max, scaleBand} from 'd3';

const svg = select('svg');

const height =+svg.attr('height');
const width =+svg.attr('width');

const render = data => {
  const xValue = d => d.population;
  const yValue = d => d.country;
  const margin = { top: 100, right: 10, bottom: 20, left: 50 };
  console.log(margin);
  
  const xScale = scaleLinear()
  	.domain([0, max(data, xValue)])
  	.range([0 , width]);
  
  //console.log(xScale.domain());
  //console.log(xScale.range());
  
  const yScale = scaleBand()
  	.domain(data.map(yValue))
  	.range([0, height]);
  
  const g = svg.append('g')
  	.attr('transform', `translate(${50 * 10}, ${50 *10})`);


  //enter() permit here to append rectangles elements to all the entries of the array
  svg.selectAll('rect').data(data)
  	.enter().append('rect')
  		.attr('y', d => yScale(yValue(d)))
  		.attr('width', d => xScale(xValue(d)))
  		.attr('height', yScale.bandwidth());
 
};

//parse the content of an .csv file into an array
csv('data.csv').then(data => {
  data.forEach(d => {
    d.population = +d.population * 1000;
  });
  //console.log(data);
  render(data);
  
});


